/*
openIRC
Copyright (C) 2006  target0 (target0@geeknode.org)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/poll.h>
#include <string.h>
#include "openirc.h"

void privmsg (ircClient *client, char *sender, char *data)
{
    ircUser *user;
    ircMsgData *msgdata;

    if ((user = ircParseUser(sender)) == NULL)
        return;

    if ((msgdata = ircParseData(data)) == NULL) {
        free(user);
        return;
    }

    if (!strcasecmp(user->nick, "target0"))
        ircSendPriv(client, "target0", "pouet (%s) (to %s)", msgdata->data, msgdata->target);

    free(msgdata);
    free(user);
}

int main()
{
    int ret;
    ircClient *client;
    client = ircGetClient();
    strcpy(client->hostname, "apinc.geeknode.org");
    client->port = 6667;
    client->timeout = 2;
    strcpy(client->nick, "target0_");
    strcpy(client->ident,"target0");
    strcpy(client->realname, "target0");

    ircAddCallback(client, IRC_MSG_PRIV, NULL, privmsg);

    ret = ircConnect(client);
    if (ret == ERR_FAILED) {
        printf("cannot connect\n");
        return 1;
    }

    if (ret == ERR_TIMEOUT) {
        printf("connection timed out\n");
        return 1;
    }

    ircHandShake(client);
    ircSendJoin(client, "#troll");

    IRC_LOOP(client);

    printf("connection reset by peer\n");
    ircDisconnect(client);
    ircFreeClient(client);
    return 0;
}
